<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>print() for C++20: include/print_concepts.h File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">print() for C++20
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">print_concepts.h File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &lt;concepts&gt;</code><br />
<code>#include &lt;iostream&gt;</code><br />
<code>#include &lt;string&gt;</code><br />
<code>#include &lt;filesystem&gt;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for print_concepts.h:</div>
<div class="dyncontent">
<div class="center"><img src="print__concepts_8h__incl.png" border="0" usemap="#include_2print__concepts_8h" alt=""/></div>
<map name="include_2print__concepts_8h" id="include_2print__concepts_8h">
<area shape="rect" title=" " alt="" coords="106,5,286,32"/>
<area shape="rect" title=" " alt="" coords="5,80,85,107"/>
<area shape="rect" title=" " alt="" coords="109,80,189,107"/>
<area shape="rect" title=" " alt="" coords="213,80,272,107"/>
<area shape="rect" title=" " alt="" coords="296,80,387,107"/>
</map>
</div>
</div><div class="textblock"><div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dyncontent">
<div class="center"><img src="print__concepts_8h__dep__incl.png" border="0" usemap="#include_2print__concepts_8hdep" alt=""/></div>
<map name="include_2print__concepts_8hdep" id="include_2print__concepts_8hdep">
<area shape="rect" title=" " alt="" coords="164,5,344,32"/>
<area shape="rect" href="print__atom_8h.html" title=" " alt="" coords="5,80,161,107"/>
<area shape="rect" href="print_8h.html" title=" " alt="" coords="149,155,263,181"/>
<area shape="rect" href="print__ostream_8h.html" title=" " alt="" coords="326,229,502,256"/>
<area shape="rect" href="print__list_8h.html" title=" " alt="" coords="237,80,380,107"/>
<area shape="rect" href="print__shortcuts_8h.html" title=" " alt="" coords="115,229,297,256"/>
</map>
</div>
</div>
<p><a href="print__concepts_8h_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="var-members"></a>
Variables</h2></td></tr>
<tr class="memitem:a7be037f25d3aca35ec2ab298e4fe0e4e"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:a7be037f25d3aca35ec2ab298e4fe0e4e"><td class="memTemplItemLeft" align="right" valign="top">concept&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__concepts_8h.html#a7be037f25d3aca35ec2ab298e4fe0e4e">Printable</a></td></tr>
<tr class="memdesc:a7be037f25d3aca35ec2ab298e4fe0e4e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Objects that can be printed to a std::ostream.  <a href="print__concepts_8h.html#a7be037f25d3aca35ec2ab298e4fe0e4e">More...</a><br /></td></tr>
<tr class="separator:a7be037f25d3aca35ec2ab298e4fe0e4e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0dc42e855b90ebe331eadf76da1ed24a"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:a0dc42e855b90ebe331eadf76da1ed24a"><td class="memTemplItemLeft" align="right" valign="top">concept&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__concepts_8h.html#a0dc42e855b90ebe331eadf76da1ed24a">PrintableList</a></td></tr>
<tr class="memdesc:a0dc42e855b90ebe331eadf76da1ed24a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Objects that can be printed as a list.  <a href="print__concepts_8h.html#a0dc42e855b90ebe331eadf76da1ed24a">More...</a><br /></td></tr>
<tr class="separator:a0dc42e855b90ebe331eadf76da1ed24a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acfda3fade5c38f41048c0dd4e65f8fe0"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:acfda3fade5c38f41048c0dd4e65f8fe0"><td class="memTemplItemLeft" align="right" valign="top">concept&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__concepts_8h.html#acfda3fade5c38f41048c0dd4e65f8fe0">HasLastElement</a></td></tr>
<tr class="memdesc:acfda3fade5c38f41048c0dd4e65f8fe0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Lists that have a defined last element.  <a href="print__concepts_8h.html#acfda3fade5c38f41048c0dd4e65f8fe0">More...</a><br /></td></tr>
<tr class="separator:acfda3fade5c38f41048c0dd4e65f8fe0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0b5fd4e23b5ae4ce823b0e118efa4891"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:a0b5fd4e23b5ae4ce823b0e118efa4891"><td class="memTemplItemLeft" align="right" valign="top">concept&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__concepts_8h.html#a0b5fd4e23b5ae4ce823b0e118efa4891">PrintablePair</a></td></tr>
<tr class="memdesc:a0b5fd4e23b5ae4ce823b0e118efa4891"><td class="mdescLeft">&#160;</td><td class="mdescRight">Objects that have a first and second member.  <a href="print__concepts_8h.html#a0b5fd4e23b5ae4ce823b0e118efa4891">More...</a><br /></td></tr>
<tr class="separator:a0b5fd4e23b5ae4ce823b0e118efa4891"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae27a2f21813c49002cf57d13f790652e"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:ae27a2f21813c49002cf57d13f790652e"><td class="memTemplItemLeft" align="right" valign="top">concept&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__concepts_8h.html#ae27a2f21813c49002cf57d13f790652e">PrintableInteger</a></td></tr>
<tr class="memdesc:ae27a2f21813c49002cf57d13f790652e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Integers but not a char.  <a href="print__concepts_8h.html#ae27a2f21813c49002cf57d13f790652e">More...</a><br /></td></tr>
<tr class="separator:ae27a2f21813c49002cf57d13f790652e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7a2d86af06580c5b0986709822bb471e"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:a7a2d86af06580c5b0986709822bb471e"><td class="memTemplItemLeft" align="right" valign="top">concept&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__concepts_8h.html#a7a2d86af06580c5b0986709822bb471e">PrintableFloat</a> = std::floating_point&lt;T&gt;</td></tr>
<tr class="memdesc:a7a2d86af06580c5b0986709822bb471e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Floating point numbers.  <a href="print__concepts_8h.html#a7a2d86af06580c5b0986709822bb471e">More...</a><br /></td></tr>
<tr class="separator:a7a2d86af06580c5b0986709822bb471e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6151497910d0d5171a62aed06bf06f35"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:a6151497910d0d5171a62aed06bf06f35"><td class="memTemplItemLeft" align="right" valign="top">concept&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__concepts_8h.html#a6151497910d0d5171a62aed06bf06f35">HasStringMethod</a></td></tr>
<tr class="memdesc:a6151497910d0d5171a62aed06bf06f35"><td class="mdescLeft">&#160;</td><td class="mdescRight">Objects with a string() method.  <a href="print__concepts_8h.html#a6151497910d0d5171a62aed06bf06f35">More...</a><br /></td></tr>
<tr class="separator:a6151497910d0d5171a62aed06bf06f35"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a44633268b78ebac99b47279732528c32"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:a44633268b78ebac99b47279732528c32"><td class="memTemplItemLeft" align="right" valign="top">concept&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__concepts_8h.html#a44633268b78ebac99b47279732528c32">UnicodeString</a></td></tr>
<tr class="memdesc:a44633268b78ebac99b47279732528c32"><td class="mdescLeft">&#160;</td><td class="mdescRight">Unicode strings.  <a href="print__concepts_8h.html#a44633268b78ebac99b47279732528c32">More...</a><br /></td></tr>
<tr class="separator:a44633268b78ebac99b47279732528c32"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab6a1189eb9b1269caae54f7ab7983c93"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:ab6a1189eb9b1269caae54f7ab7983c93"><td class="memTemplItemLeft" align="right" valign="top">concept&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__concepts_8h.html#ab6a1189eb9b1269caae54f7ab7983c93">StdPrintable</a></td></tr>
<tr class="memdesc:ab6a1189eb9b1269caae54f7ab7983c93"><td class="mdescLeft">&#160;</td><td class="mdescRight">Objects that are printable in the std namespace.  <a href="print__concepts_8h.html#ab6a1189eb9b1269caae54f7ab7983c93">More...</a><br /></td></tr>
<tr class="separator:ab6a1189eb9b1269caae54f7ab7983c93"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a98cd10e7572b303706baeb59ab097a3e"><td class="memTemplParams" colspan="2">template&lt;class T &gt; </td></tr>
<tr class="memitem:a98cd10e7572b303706baeb59ab097a3e"><td class="memTemplItemLeft" align="right" valign="top">concept&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="print__concepts_8h.html#a98cd10e7572b303706baeb59ab097a3e">DefaultPrintable</a></td></tr>
<tr class="memdesc:a98cd10e7572b303706baeb59ab097a3e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Objects that are printable by default.  <a href="print__concepts_8h.html#a98cd10e7572b303706baeb59ab097a3e">More...</a><br /></td></tr>
<tr class="separator:a98cd10e7572b303706baeb59ab097a3e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Defines concepts for different types of printable objects. Requires C++20 features enabled and a recent compiler. </p>
</div><h2 class="groupheader">Variable Documentation</h2>
<a id="a98cd10e7572b303706baeb59ab097a3e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a98cd10e7572b303706baeb59ab097a3e">&#9670;&nbsp;</a></span>DefaultPrintable</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">concept DefaultPrintable</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Initial value:</b><div class="fragment"><div class="line">= </div>
<div class="line">        StdPrintable&lt;T&gt; ||</div>
<div class="line">        std::same_as&lt;T, std::filesystem::path&gt;</div>
</div><!-- fragment -->
<p>Objects that are printable by default. </p>
<p>(Needed to avoid that strings, filepaths, etc. aren't printed as lists). </p>

</div>
</div>
<a id="acfda3fade5c38f41048c0dd4e65f8fe0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acfda3fade5c38f41048c0dd4e65f8fe0">&#9670;&nbsp;</a></span>HasLastElement</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">concept HasLastElement</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Initial value:</b><div class="fragment"><div class="line">= <a class="code" href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">requires</a> (T a) {</div>
<div class="line">        {a.end()} -&gt; std::bidirectional_iterator;</div>
<div class="line">    }</div>
</div><!-- fragment -->
<p>Lists that have a defined last element. </p>
<p>This is, e.g., the case for std::map but not for std::unordered_map. Needed for formatting truncated lists ("[1, 2, 3, ..., 100]" vs. "[17, 3, 52, 1, ...]"). </p>

</div>
</div>
<a id="a6151497910d0d5171a62aed06bf06f35"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a6151497910d0d5171a62aed06bf06f35">&#9670;&nbsp;</a></span>HasStringMethod</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">concept HasStringMethod</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Initial value:</b><div class="fragment"><div class="line">= <a class="code" href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">requires</a>(T t) {</div>
<div class="line">    {t.string()} -&gt; std::same_as&lt;std::string&gt;;    </div>
<div class="line">}</div>
</div><!-- fragment -->
<p>Objects with a string() method. </p>

</div>
</div>
<a id="a7be037f25d3aca35ec2ab298e4fe0e4e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7be037f25d3aca35ec2ab298e4fe0e4e">&#9670;&nbsp;</a></span>Printable</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">concept Printable</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Initial value:</b><div class="fragment"><div class="line">= <a class="code" href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">requires</a>(T t) {</div>
<div class="line">    {std::cout &lt;&lt; t} -&gt; std::same_as&lt;std::ostream&amp;&gt;;</div>
<div class="line">}</div>
</div><!-- fragment -->
<p>Objects that can be printed to a std::ostream. </p>

</div>
</div>
<a id="a7a2d86af06580c5b0986709822bb471e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7a2d86af06580c5b0986709822bb471e">&#9670;&nbsp;</a></span>PrintableFloat</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">concept PrintableFloat = std::floating_point&lt;T&gt;</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Floating point numbers. </p>

</div>
</div>
<a id="ae27a2f21813c49002cf57d13f790652e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae27a2f21813c49002cf57d13f790652e">&#9670;&nbsp;</a></span>PrintableInteger</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">concept PrintableInteger</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Initial value:</b><div class="fragment"><div class="line">= </div>
<div class="line">    std::integral&lt;T&gt; &amp;&amp;</div>
<div class="line">    std::same_as&lt;char, T&gt; == <span class="keyword">false</span></div>
</div><!-- fragment -->
<p>Integers but not a char. </p>

</div>
</div>
<a id="a0dc42e855b90ebe331eadf76da1ed24a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0dc42e855b90ebe331eadf76da1ed24a">&#9670;&nbsp;</a></span>PrintableList</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">concept PrintableList</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Initial value:</b><div class="fragment"><div class="line">= <a class="code" href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">requires</a> (T a) {</div>
<div class="line">        {a.begin()} -&gt; std::forward_iterator;</div>
<div class="line">    }</div>
</div><!-- fragment -->
<p>Objects that can be printed as a list. </p>
<p>Requires that begin() returns a std::forward_iterator. Examples are std::vector and std::map. </p>

</div>
</div>
<a id="a0b5fd4e23b5ae4ce823b0e118efa4891"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0b5fd4e23b5ae4ce823b0e118efa4891">&#9670;&nbsp;</a></span>PrintablePair</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">concept PrintablePair</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Initial value:</b><div class="fragment"><div class="line">= <a class="code" href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">requires</a> (T a) {</div>
<div class="line">        {a.first};</div>
<div class="line">        {a.second};</div>
<div class="line">    }</div>
</div><!-- fragment -->
<p>Objects that have a first and second member. </p>

</div>
</div>
<a id="ab6a1189eb9b1269caae54f7ab7983c93"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab6a1189eb9b1269caae54f7ab7983c93">&#9670;&nbsp;</a></span>StdPrintable</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">concept StdPrintable</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Initial value:</b><div class="fragment"><div class="line">= <a class="code" href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">requires</a> (T t) {</div>
<div class="line">    {std::operator&lt;&lt;(std::cout, t)} -&gt; std::same_as&lt;std::ostream&amp;&gt;;</div>
<div class="line">}</div>
</div><!-- fragment -->
<p>Objects that are printable in the std namespace. </p>

</div>
</div>
<a id="a44633268b78ebac99b47279732528c32"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a44633268b78ebac99b47279732528c32">&#9670;&nbsp;</a></span>UnicodeString</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">concept UnicodeString</td>
        </tr>
      </table>
</div><div class="memdoc">
<b>Initial value:</b><div class="fragment"><div class="line">=</div>
<div class="line">    std::same_as&lt;T, std::u8string&gt; ||</div>
<div class="line">    std::same_as&lt;T, std::u16string&gt; ||</div>
<div class="line">    std::same_as&lt;T, std::u32string&gt;</div>
</div><!-- fragment -->
<p>Unicode strings. </p>

</div>
</div>
</div><!-- contents -->
<div class="ttc" id="aprint__atom_8h_html_a08a0df05930aa51f1c30e856b5e6ff99"><div class="ttname"><a href="print__atom_8h.html#a08a0df05930aa51f1c30e856b5e6ff99">cpp20print::printing::detail::requires</a></div><div class="ttdeci">requires(concepts::PrintableInteger&lt; T &gt;==false) &amp;&amp;(concepts</div><div class="ttdoc">Prints single object. Use default operator&lt;&lt; if defined.</div><div class="ttdef"><b>Definition:</b> print_atom.h:35</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
